 ##################################################################################
 ##
 ## Project:  Aurora 64B/66B
 ## Company:  Xilinx
 ##
 ##
 ##
 ## (c) Copyright 2008 - 2014 Xilinx, Inc. All rights reserved.
 ##
 ## This file contains confidential and proprietary information
 ## of Xilinx, Inc. and is protected under U.S. and
 ## international copyright and other intellectual property
 ## laws.
 ##
 ## DISCLAIMER
 ## This disclaimer is not a license and does not grant any
 ## rights to the materials distributed herewith. Except as
 ## otherwise provided in a valid license issued to you by
 ## Xilinx, and to the maximum extent permitted by applicable
 ## law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
 ## WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
 ## AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
 ## BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
 ## INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
 ## (2) Xilinx shall not be liable (whether in contract or tort,
 ## including negligence, or under any other theory of
 ## liability) for any loss or damage of any kind or nature
 ## related to, arising under or in connection with these
 ## materials, including for any direct, or any indirect,
 ## special, incidental, or consequential loss or damage
 ## (including loss of data, profits, goodwill, or any type of
 ## loss or damage suffered as a result of any action brought
 ## by a third party) even if such damage or loss was
 ## reasonably foreseeable or Xilinx had been advised of the
 ## possibility of the same.
 ##
 ## CRITICAL APPLICATIONS
 ## Xilinx products are not designed or intended to be fail-
 ## safe, or for use in any application requiring fail-safe
 ## performance, such as life-support or safety devices or
 ## systems, Class III medical devices, nuclear facilities,
 ## applications related to the deployment of airbags, or any
 ## other applications that could lead to death, personal
 ## injury, or severe property or environmental damage
 ## (individually and collectively, "Critical
 ## Applications"). Customer assumes the sole risk and
 ## liability of any use of Xilinx products in Critical
 ## Applications, subject only to applicable laws and
 ## regulations governing limitations on product liability.
 ##
 ## THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
 ## PART OF THIS FILE AT ALL TIMES.
 ##
 ###################################################################################################
 ##
 ##  aurora_64b66b_0_exdes
 ##
 ##  Description: This is the example design constraints file for a 4 lane Aurora
 ##               core.
 ##               This is example design xdc.
 ##               Note: User need to set proper IO standards for the LOC's mentioned below.
 ###################################################################################################

################################################################################
  

  ################################ CLOCK CONSTRAINTS #########################
  # User Clock Contraint: the value is selected based on the line rate of the module
  #create_clock -period 23.702 [get_pins aurora_64b66b_0_block_i/clock_module_i/user_clk_net_i/I]

  # SYNC Clock Constraint
  #create_clock -period 11.851   [get_pins aurora_64b66b_0_block_i/clock_module_i/sync_clock_net_i/I]

  ################################ IP LEVEL CONSTRAINTS START ################
  # Following constraints present in aurora_64b66b_0.xdc
  # Create clock constraint for TXOUTCLK from GT
  #create_clock -period 11.851   [get_pins -hier -filter {name=~*aurora_64b66b_0_wrapper_i*aurora_64b66b_0_multi_gt_i*aurora_64b66b_0_gtx_inst/gtxe2_i/TXOUTCLK}]
  # Create clock constraint for RXOUTCLK from GT
  #create_clock -period 11.851   [get_pins -hier -filter {name=~*aurora_64b66b_0_wrapper_i*aurora_64b66b_0_multi_gt_i*aurora_64b66b_0_gtx_inst/gtxe2_i/RXOUTCLK}]
  ################################ IP LEVEL CONSTRAINTS END ##################
  # Reference clock contraint for GTX
  create_clock -name gtrefclk1_in -period 7.407  [get_ports GTXQ3_P]
   set_clock_groups -asynchronous -group [get_clocks gtrefclk1_in -include_generated_clocks]
        ### DRP Clock Constraint
# create_clock -name drpclk_in -period 16.667  [get_ports DRP_CLK_IN_P]
#   set_clock_groups -asynchronous -group [get_clocks drpclk_in -include_generated_clocks]
  
  # 200MHz board Clock Constraint
  create_clock -name init_clk_i -period 20.000   [get_ports INIT_CLK_P]
   set_clock_groups -asynchronous -group [get_clocks init_clk_i -include_generated_clocks]
  
  ###### No cross clock domain analysis. Domains are not related ##############
  ## set_false_path -from [get_clocks init_clk] -to [get_clocks user_clk]
  ## set_false_path -from [get_clocks user_clk] -to [get_clocks init_clk]
  ## set_false_path -from [get_clocks init_clk] -to [get_clocks sync_clk]
  ## set_false_path -from [get_clocks sync_clk] -to [get_clocks init_clk]

  ## ## set_false_path -from init_clk -to [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/mmcm_adv_inst/CLKOUT0]]
  ##
  ## ## set_false_path -from [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/mmcm_adv_inst/CLKOUT0]] -to init_clk
  ##
  ## ## set_false_path -from init_clk -to [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/mmcm_adv_inst/CLKOUT1]]
  ##
  ## ## set_false_path -from [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/mmcm_adv_inst/CLKOUT1]] -to init_clk
  ##
  ## ## set_false_path -from [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/initclk_bufg_i/O]] -to [get_clocks -of_objects [get_pins -hier -filter {name=~*aurora_64b66b_0_i*inst*aurora_64b66b_0_wrapper_i*aurora_64b66b_0_multi_gt_i*aurora_64b66b_0_gtx_inst/gtxe2_i/RXOUTCLK}]]
  ##
  ## ## set_false_path -from [get_clocks -of_objects [get_pins -hier -filter {name=~*aurora_64b66b_0_i*inst*aurora_64b66b_0_wrapper_i*aurora_64b66b_0_multi_gt_i*aurora_64b66b_0_gtx_inst/gtxe2_i/RXOUTCLK}]] -to [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/initclk_bufg_i/O]]
  ##
  ## ## set_false_path -from [get_clocks -of_objects [get_pins -hier -filter {name=~*aurora_64b66b_0_i*inst*aurora_64b66b_0_wrapper_i*aurora_64b66b_0_multi_gt_i*aurora_64b66b_0_gtx_inst/gtxe2_i/RXOUTCLK}]] -to [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/mmcm_adv_inst/CLKOUT0]]
  ##
  ## ## set_false_path -from [get_clocks -of_objects [get_pins aurora_64b66b_0_block_i/clock_module_i/mmcm_adv_inst/CLKOUT0]] -to [get_clocks -of_objects [get_pins -hier -filter {name=~*aurora_64b66b_0_i*inst*aurora_64b66b_0_wrapper_i*aurora_64b66b_0_multi_gt_i*aurora_64b66b_0_gtx_inst/gtxe2_i/RXOUTCLK}]]


  ## GT CLOCK Locations   ##
  # Differential SMA Clock Connection
#  set_property LOC C8 [get_ports GTXQ3_P]
#  set_property LOC C7 [get_ports GTXQ3_N]
  


   set_property LOC GTXE2_CHANNEL_X0Y12 [get_cells  aurora_64b66b_0_block_i/aurora_64b66b_0_i/inst/aurora_64b66b_0_wrapper_i/aurora_64b66b_0_multi_gt_i/aurora_64b66b_0_gtx_inst/gtxe2_i]



   set_property LOC GTXE2_CHANNEL_X0Y13 [get_cells  aurora_64b66b_0_block_i/aurora_64b66b_0_i/inst/aurora_64b66b_0_wrapper_i/aurora_64b66b_0_multi_gt_i/aurora_64b66b_0_gtx_inst_lane1/gtxe2_i]



   set_property LOC GTXE2_CHANNEL_X0Y14 [get_cells  aurora_64b66b_0_block_i/aurora_64b66b_0_i/inst/aurora_64b66b_0_wrapper_i/aurora_64b66b_0_multi_gt_i/aurora_64b66b_0_gtx_inst_lane2/gtxe2_i]



   set_property LOC GTXE2_CHANNEL_X0Y15 [get_cells  aurora_64b66b_0_block_i/aurora_64b66b_0_i/inst/aurora_64b66b_0_wrapper_i/aurora_64b66b_0_multi_gt_i/aurora_64b66b_0_gtx_inst_lane3/gtxe2_i]



  #
#  connect_debug_port dbg_hub/clk [get_nets INIT_CLK_i]
#  set_property C_CLK_INPUT_FREQ_HZ 50000000 [get_debug_cores dbg_hub]
#  set_property C_ENABLE_CLK_DIVIDER true [get_debug_cores dbg_hub]
  #

 # false path constraints to the example design logic
 set_false_path -to [get_pins -hier *aurora_64b66b_0_cdc_to*/D]


#####################################################################################################
set_property -dict { PACKAGE_PIN AD11  IOSTANDARD LVDS     } [get_ports { INIT_CLK_N }]; #IO_L12N_T1_MRCC_33 Sch=sysclk_n
set_property -dict { PACKAGE_PIN AD12  IOSTANDARD LVDS     } [get_ports { INIT_CLK_P }]; #IO_L12P_T1_MRCC_33 Sch=sysclk_p
              #set_property LOC D17 [get_ports INIT_CLK_P]
              #set_property LOC D18 [get_ports INIT_CLK_N]
set_property -dict { PACKAGE_PIN E20   IOSTANDARD LVDS_25 } [get_ports { DRP_CLK_IN_N }]; #IO_L12N_T1_MRCC_17 Sch=fmc_clk0_m2c_n
set_property -dict { PACKAGE_PIN F20   IOSTANDARD LVDS_25 } [get_ports { DRP_CLK_IN_P }]; #IO_L12P_T1_MRCC_17 Sch=fmc_clk0_m2c_p
              #set_property LOC AG29 [get_ports DRP_CLK_IN]
set_property -dict { PACKAGE_PIN E18   IOSTANDARD LVCMOS25 } [get_ports { RESET }]; #IO_25_17 Sch=btnc
              #set_property LOC G19 [get_ports RESET]
set_property -dict { PACKAGE_PIN M19   IOSTANDARD LVCMOS25 } [get_ports { PMA_INIT }]; #IO_0_15 Sch=btnd
              #set_property LOC K18 [get_ports PMA_INIT]
set_property -dict { PACKAGE_PIN W23   IOSTANDARD LVCMOS33 } [get_ports { CHANNEL_UP }]; #IO_L20P_T3_A08_D24_14 Sch=led[7]
              #set_property LOC A20 [get_ports CHANNEL_UP]
set_property -dict { PACKAGE_PIN T28   IOSTANDARD LVCMOS33 } [get_ports { LANE_UP[0] }]; #IO_L11N_T1_SRCC_14 Sch=led[0]
              #set_property LOC A17 [get_ports LANE_UP[0]]
set_property -dict { PACKAGE_PIN V19   IOSTANDARD LVCMOS33 } [get_ports { LANE_UP[1] }]; #IO_L19P_T3_A10_D26_14 Sch=led[1]
            #set_property LOC A16 [get_ports LANE_UP[1]]
set_property -dict { PACKAGE_PIN U30   IOSTANDARD LVCMOS33 } [get_ports { LANE_UP[2] }]; #IO_L15N_T2_DQS_DOUT_CSO_B_14 Sch=led[2]
            #set_property LOC B20 [get_ports LANE_UP[2]]
set_property -dict { PACKAGE_PIN U29   IOSTANDARD LVCMOS33 } [get_ports { LANE_UP[3] }]; #IO_L15P_T2_DQS_RDWR_B_14 Sch=led[3]
            #set_property LOC C20  [get_ports LANE_UP[3]]
set_property -dict { PACKAGE_PIN AG30  IOSTANDARD LVCMOS33 } [get_ports { HARD_ERR }]; #IO_L18P_T2_13 Sch=jc[8]
              #set_property LOC Y15  [get_ports HARD_ERR]   
set_property -dict { PACKAGE_PIN AK30  IOSTANDARD LVCMOS33 } [get_ports { SOFT_ERR }]; #IO_L15N_T2_DQS_13 Sch=jc[9]
              #set_property LOC AH10  [get_ports SOFT_ERR]   
set_property -dict { PACKAGE_PIN AK28  IOSTANDARD LVCMOS33 } [get_ports { jc[7] }]; #IO_L20N_T3_13 Sch=jc[10]
               #set_property LOC AD16  [get_ports DATA_ERR_COUNT[0]]   
set_property -dict { PACKAGE_PIN V27   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[0] }]; #IO_L16N_T2_A15_D31_14 Sch=jd[1]
               #set_property LOC Y19  [get_ports DATA_ERR_COUNT[1]]   
set_property -dict { PACKAGE_PIN Y30   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[1] }]; #IO_L8P_T1_13 Sch=jd[2]
               #set_property LOC Y18  [get_ports DATA_ERR_COUNT[2]]   
set_property -dict { PACKAGE_PIN V24   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[2] }]; #IO_L23N_T3_A02_D18_14 Sch=jd[3]
               #set_property LOC AA18  [get_ports DATA_ERR_COUNT[3]]   
set_property -dict { PACKAGE_PIN W22   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[3] }]; #IO_L24N_T3_A00_D16_14 Sch=jd[4]
               #set_property LOC AB18  [get_ports DATA_ERR_COUNT[4]]   
set_property -dict { PACKAGE_PIN U24   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[4] }]; #IO_L23P_T3_A03_D19_14 Sch=jd[7]
               #set_property LOC AB19  [get_ports DATA_ERR_COUNT[5]]   
set_property -dict { PACKAGE_PIN Y26   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[5] }]; #IO_L1P_T0_13 Sch=jd[8]
               #set_property LOC AC19  [get_ports DATA_ERR_COUNT[6]]   
set_property -dict { PACKAGE_PIN V22   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[6] }]; #IO_L22N_T3_A04_D20_14 Sch=jd[9]
               #set_property LOC AB17  [get_ports DATA_ERR_COUNT[7]]   
set_property -dict { PACKAGE_PIN W21   IOSTANDARD LVCMOS33 } [get_ports { DATA_ERR_COUNT[7] }]; #IO_L24P_T3_A01_D17_14 Sch=jd[10]
 
set_property -dict { PACKAGE_PIN Y23   IOSTANDARD LVCMOS33 } [get_ports { UART_RX_OUT }]; #IO_L1P_T0_12 Sch=uart_rx_out
set_property -dict { PACKAGE_PIN Y20   IOSTANDARD LVCMOS33 } [get_ports { UART_TX_IN }]; #IO_0_12 Sch=uart_tx_in
set_property -dict { PACKAGE_PIN W19   IOSTANDARD LVCMOS33 } [get_ports { FAN_PWM }]; #IO_25_14 Sch=fan_pwm
set_property -dict { PACKAGE_PIN AC24  IOSTANDARD LVCMOS33 } [get_ports { FMC_SCL }]; #IO_L9P_T1_DQS_12 Sch=fmc_scl
set_property -dict { PACKAGE_PIN AD24  IOSTANDARD LVCMOS33 } [get_ports { FMC_SDA }]; #IO_L9N_T1_DQS_12 Sch=fmc_sda


#set_property BITSTREAM.General.UnconstrainedPins {Allow} [current_design] 
# the actual transceiver pins are unconstrained in the example but we'll assign them to Geneysy2 pins
#GTXQ3_P,
#GTXQ3_N,
#RXP[0]. RXP[1]. RXP[2]. RXP[3].
#RXN[0]. RXN[1]. RXN[2]. RXN[3].
#TXP[0]. TXP[1]. TXP[2]. TXP[3].
#TXN[0]. TXN[1]. TXN[2]. TXN[3].
set_property -dict { PACKAGE_PIN C8 } [get_ports { GTXQ3_P }]; # DISPLY_CLK_P
set_property -dict { PACKAGE_PIN C7 } [get_ports { GTXQ3_N }]; # DISPLY_CLK_N 
set_property -dict { PACKAGE_PIN E4 } [get_ports { RXP[0] }]; # RX_LANE0_P
set_property -dict { PACKAGE_PIN E3 } [get_ports { RXN[0] }]; # RX_LANE0_N 
set_property -dict { PACKAGE_PIN D6 } [get_ports { RXP[1] }]; # RX_LANE1_P 
set_property -dict { PACKAGE_PIN D5 } [get_ports { RXN[1] }]; # RX_LANE1_N 
set_property -dict { PACKAGE_PIN B6 } [get_ports { RXP[2] }]; # RX_LANE2_P 
set_property -dict { PACKAGE_PIN B5 } [get_ports { RXN[2] }]; # RX_LANE2_N 
set_property -dict { PACKAGE_PIN A8 } [get_ports { RXP[3] }]; # RX_LANE3_P 
set_property -dict { PACKAGE_PIN A7 } [get_ports { RXN[3] }]; # RX_LANE3_N 
set_property -dict { PACKAGE_PIN D2 } [get_ports { TXP[0] }]; # TX_LANE0_P 
set_property -dict { PACKAGE_PIN D1 } [get_ports { TXN[0] }]; # TX_LANE0_N 
set_property -dict { PACKAGE_PIN C4 } [get_ports { TXP[1] }]; # TX_LANE1_P 
set_property -dict { PACKAGE_PIN C3 } [get_ports { TXN[1] }]; # TX_LANE1_N 
set_property -dict { PACKAGE_PIN B2 } [get_ports { TXP[2] }]; # TX_LANE2_P 
set_property -dict { PACKAGE_PIN B1 } [get_ports { TXN[2] }]; # TX_LANE2_N 
set_property -dict { PACKAGE_PIN A4 } [get_ports { TXP[3] }]; # TX_LANE3_P 
set_property -dict { PACKAGE_PIN A3 } [get_ports { TXN[3] }]; # TX_LANE3_N 
             #// DRP CLK needs a clock LOC
    
  ##Note: User should add IOSTANDARD based upon the board
  #       Below IOSTANDARD's are place holders and need to be changed as per the device and board
              #set_property IOSTANDARD LVDS_25 [get_ports INIT_CLK_P]
              #set_property IOSTANDARD LVDS_25 [get_ports INIT_CLK_N]
              #set_property IOSTANDARD LVCMOS18 [get_ports RESET]
              #set_property IOSTANDARD LVCMOS18 [get_ports PMA_INIT]
    
              #set_property IOSTANDARD LVCMOS18 [get_ports CHANNEL_UP]
              #set_property IOSTANDARD LVCMOS18 [get_ports LANE_UP[0]]
            #set_property IOSTANDARD LVCMOS18 [get_ports LANE_UP[1]]
            #set_property IOSTANDARD LVCMOS18 [get_ports LANE_UP[2]]
            #set_property IOSTANDARD LVCMOS18  [get_ports LANE_UP[3]]
               #set_property IOSTANDARD LVCMOS18 [get_ports HARD_ERR]   
               #set_property IOSTANDARD LVCMOS18 [get_ports SOFT_ERR]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[0]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[1]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[2]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[3]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[4]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[5]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[6]]   
               #set_property IOSTANDARD LVCMOS18 [get_ports DATA_ERR_COUNT[7]]   
    
              #set_property IOSTANDARD LVCMOS18 [get_ports DRP_CLK_IN]
              #// DRP CLK needs a clock IOSTDLOC
    
